package com.mortals.xhx.module.basic.web;

import com.mortals.framework.annotation.UnAuth;
import com.mortals.framework.common.Rest;
import com.mortals.framework.exception.AppException;
import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.base.system.param.service.ParamService;
import com.mortals.xhx.common.code.YesNoEnum;
import com.mortals.xhx.module.basic.model.BasicSetQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.bind.annotation.*;
import com.mortals.framework.model.Context;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.mortals.framework.web.BaseCRUDJsonBodyMappingController;
import com.mortals.xhx.module.basic.model.BasicSetEntity;
import com.mortals.xhx.module.basic.service.BasicSetService;
import org.apache.commons.lang3.ArrayUtils;
import com.mortals.framework.util.StringUtils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.alibaba.fastjson.JSONObject;

import java.util.Arrays;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import static com.mortals.framework.ap.SysConstains.*;

/**
 * 基础设置
 *
 * @author zxfei
 * @date 2023-05-23
 */
@RestController
@RequestMapping("basic/set")
public class BasicSetController extends BaseCRUDJsonBodyMappingController<BasicSetService, BasicSetEntity, Long> {

    @Autowired
    private ParamService paramService;

    public BasicSetController() {
        super.setModuleDesc("基础设置");
    }

    @Override
    protected void init(Map<String, Object> model, Context context) {
        this.addDict(model, "showPhoto", paramService.getParamBySecondOrganize("BasicSet", "showPhoto"));
        this.addDict(model, "showName", paramService.getParamBySecondOrganize("BasicSet", "showName"));
        this.addDict(model, "showPost", paramService.getParamBySecondOrganize("BasicSet", "showPost"));
        this.addDict(model, "showWork", paramService.getParamBySecondOrganize("BasicSet", "showWork"));
        this.addDict(model, "showPhone", paramService.getParamBySecondOrganize("BasicSet", "showPhone"));
        this.addDict(model, "showElect", paramService.getParamBySecondOrganize("BasicSet", "showElect"));
        this.addDict(model, "showMeet", paramService.getParamBySecondOrganize("BasicSet", "showMeet"));
        this.addDict(model, "meetEnd", YesNoEnum.getEnumMap());


        super.init(model, context);
    }


    @Override
    @UnAuth
    public Rest<Object> list(@RequestBody BasicSetEntity query) {
        return super.list(query);
    }

    @Override
    protected void saveBefore(BasicSetEntity entity, Map<String, Object> model, Context context) throws AppException {

        BasicSetEntity basicSetEntity = this.service.selectOne(new BasicSetQuery(), context);
        if (!ObjectUtils.isEmpty(basicSetEntity)) {
            entity.setId(basicSetEntity.getId());
        }
        super.saveBefore(entity, model, context);


    }
}